' **** OpenSaveDialog_HostForm2.BAS


' Example program to call dialog box OpenSaveDialog2.BAS


' *** Command line parameters:

' 1 "New Project" "Graphic files (*.png;*.bmp;*.jpg)|All files (*.*)|*.*" "c:\users" "picture.png" 1

' mode "title" "string for filters description and filters" "start directory" "filename" Show_hidden_flag

'   title (mandatory or "")

'   filters: (mandatory)
'       string to show selectable file filters (file extension)
'       Syntax:
'           "file type description | *.extension" (for single extension filetypes)
'           "files type description | *.ext1;*.ext2;*.ext3" (for multiple extension filetypes)

'   start directory: (optional)
'       start directory/folder to show in dialog box.

'   filename: (optional)
'       default filename for save and save as

'   Show_hidden_flag: (optional parameter)
'       Flag to show/no show hidden and system files and directories (True/False)
'       == 0 -> False      == 1 -> True

' All strings must be in quotes.

' mode:

'    - 6 options for dialog box type (title):
'        1="New"     (Title parameter is ignored. Option is "")
'        2="Open"    (Title parameter is ignored. Option is "")
'        3="Save"    (Title parameter is ignored. Option is "")
'        4="Save as" (Title parameter is ignored. Option is "")
'        5="Custom title for NEW/SAVE/SAVE AS"   (Title parameter is mandatory)
'        6="Custom title for OPEN"   (Title parameter is mandatory)

' Filename, start directory and show hidden flag are optional and can be parsed in any order.

' Feb 24 2022 - Public version released


': This program uses
': InForm - GUI library for QB64 - v1.2
': Fellippe Heitor, 2016-2020 - fellippe@qb64.org - @fellippeheitor
': https://github.com/FellippeHeitor/InForm
'-----------------------------------------------------------

': Controls' IDs: ------------------------------------------------------------------
Rem NOTICE: THIS FORM HAS BEEN RECENTLY EDITED
'>> The controls in the list below may have been added or renamed,
'>> and previously existing controls may have been deleted since
'>> this program's structure was first generated.
'>> Make sure to check your code in the events SUBs so that
'>> you can take your recent edits into consideration.
': ---------------------------------------------------------------------------------
Dim Shared FormHost As Long
Dim Shared NewButton As Long
Dim Shared OpenButton As Long
Dim Shared SaveButton As Long
Dim Shared SaveAsButton As Long
Dim Shared CustomNewBT As Long
Dim Shared CustomOpenBT As Long
Dim Shared CustomSaveBT As Long
Dim Shared CustomSaveAsBT As Long
Dim Shared customNewTextTB As Long
Dim Shared customOpenTextTB As Long
Dim Shared customSaveTextTB As Long
Dim Shared customSaveAsTextTB As Long

Dim Shared ShowHiddenFilesCB As Long
Dim Shared SetStartDirectoryCB As Long
Dim Shared startDirectoryTB As Long
Dim Shared SetDefaultFileNameCB As Long
Dim Shared FileNameTB As Long


' ***
' General use variables
' ***

Const TempFile$ = "__OpenSaveDialog__.tmp" ' temporary file to store filenames/foldernames and choen filename
Dim Shared TempDirFile$

$If WIN Then
    Const slash$ = "\"
$Else
    Const slash$ = "/"
$End If



': External modules: ---------------------------------------------------------------
'$INCLUDE:'InForm\InForm.bi'
'$INCLUDE:'InForm\xp.uitheme'
'$INCLUDE:'OpenSaveDialog_HostForm2.frm'

': Event procedures: ---------------------------------------------------------------
Sub __UI_BeforeInit

    TempDirFile$ = _StartDir$ + slash$ + TempFile$

End Sub


Sub __UI_OnLoad

End Sub

Sub __UI_BeforeUpdateDisplay
    'This event occurs at approximately 30 frames per second.
    'You can change the update frequency by calling SetFrameRate DesiredRate%

End Sub

Sub __UI_BeforeUnload
    'If you set __UI_UnloadSignal = False here you can
    'cancel the user's request to close.

End Sub

Sub __UI_Click (id As Long)
    Select Case id
        'Case OpenSaveForm

        Case NewButton
            DialogMode = 1
            'Control(Frame1).Hidden = False
            'Control(Frame2).Hidden = True
            Call OpenSaveDialogBox(1, "New Project",_
                "Project (*.mpr)|*.mpr|Graphic files (*.jpg;*.bmp;*.png)|*.jpg;*.bmp;*.png|"+_
                "AS files (*.as)|*.as|All files (*.*)|*.*")

        Case OpenButton
            DialogMode = 2
            Call OpenSaveDialogBox(2, "Open Project", "Project (*.mpr)|*.mpr|All files (*.*)|*.*")

        Case SaveButton
            DialogMode = 3
            Call OpenSaveDialogBox(3, "Save Project", "Project (*.mpr)|*.mpr|All files (*.*)|*.*")

        Case SaveAsButton
            DialogMode = 4
            Call OpenSaveDialogBox(4, "Save as", "Project (*.mpr)|*.mpr|All files (*.*)|*.*")

        Case CustomNewBT
            DialogMode = 5
            Call OpenSaveDialogBox(5, Text(customNewTextTB), "Documents (*.doc;*.docx;*.txt)|*.doc;*.docx;*.txt|All files (*.*)|*.*")

        Case CustomOpenBT
            DialogMode = 6
            Call OpenSaveDialogBox(6, text(customOpenTextTB ),  "QB files (*.bas;*.frm)|*.bas;*.frm|"+_
                    "BASIC files (*.bas)|*.bas|Form files (*.frm)|*.frm|All files (*.*)|*.*")

        Case CustomSaveBT
            DialogMode = 5
            Call OpenSaveDialogBox(5, text(customSaveTextTB ),  "QB files (*.bas;*.frm)|*.bas;*.frm|"+_
                    "BASIC files (*.bas)|*.bas|Form files (*.frm)|*.frm|All files (*.*)|*.*")

        Case CustomSaveAsBT
            DialogMode = 5
            Call OpenSaveDialogBox(5, text(customSaveAsTextTB ),  "QB files (*.bas;*.frm)|*.bas;*.frm|"+_
                    "BASIC files (*.bas)|*.bas|Form files (*.frm)|*.frm|All files (*.*)|*.*")

            'Case ShowHiddenFilesCB

    End Select
End Sub


Sub __UI_MouseEnter (id As Long)

End Sub


Sub __UI_MouseLeave (id As Long)

End Sub


Sub __UI_FocusIn (id As Long)
    'Select Case id
    '    Case OpenSaveForm

    '    Case NewButton

    '    Case OpenButton

    '    Case SaveButton

    '    Case SaveAsButton

    'End Select
End Sub


Sub __UI_FocusOut (id As Long)
    'This event occurs right before a control loses focus.
    'To prevent a control from losing focus, set __UI_KeepFocus = True below.

End Sub


Sub __UI_MouseDown (id As Long)

End Sub


Sub __UI_MouseUp (id As Long)

End Sub


Sub __UI_KeyPress (id As Long)
    'When this event is fired, __UI_KeyHit will contain the code of the key hit.
    'You can change it and even cancel it by making it = 0
    'Select Case id
    '    Case ShowHiddenFilesCB
    'End Select
End Sub


Sub __UI_TextChanged (id As Long)

End Sub


Sub __UI_ValueChanged (id As Long)
    'Select Case id
    '    Case ShowHiddenFilesCB
    'End Select

End Sub


Sub __UI_FormResized

End Sub


' ***
' calls Sub OpenSaveDialog program to show dialog box
' ***


'   title (mandatory or "")

'   filters: (mandatory)
'       string to show selectable file filters (file extension)
'       Syntax:
'           "file type description | *.extension" (for single extension filetypes)
'           "files type description | *.ext1;*.ext2;*.ext3" (for multiple extension filetypes)

' mode:

'    - 6 ways to show dialog (title):
'        1="New"     (Title parameter is ignored. Option is "")
'        2="Open"    (Title parameter is ignored. Option is "")
'        3="Save"    (Title parameter is ignored. Option is "")
'        4="Save as" (Title parameter is ignored. Option is "")
'        5="Custom title for NEW/SAVE/SAVE AS"   (Title parameter is mandatory)
'        6="Custom title for OPEN"   (Title parameter is mandatory)


Sub OpenSaveDialogBox (Mode%%, Title$, Filters$)

    ExePath$ = _StartDir$
    If Right$(ExePath$, 1) <> slash$ Then ExePath$ = ExePath$ + slash$ 'adds slash if needed

    If Control(ShowHiddenFilesCB).Value Then Hidden$ = "1" Else Hidden$ = "0"
    ' a space after "\" is mandatory to avoid bug in parsed parameters if path ends with "\" char
    If Control(SetStartDirectoryCB).Value Then StartDir$ = Text(startDirectoryTB) + " " Else StartDir$ = ""
    If Control(SetDefaultFileNameCB).Value Then Filename$ = Text(FileNameTB) Else Filename$ = ""

    parameters$=Str$(Mode%%) + " " + Chr$(34) + Title$ + Chr$(34) +" " + Chr$(34) + filters$ + Chr$(34)+" "+_
                chr$(34)+StartDir$+chr$(34)+" "+chr$(34)+Filename$+chr$(34)+" "+Hidden$

    $If WIN Then
        Shell Chr$(34) + ExePath$ + "OpenSaveDialog2" + Chr$(34) + " " + parameters$

    $Else
        Shell Chr$(34) + ExePath$ + "./OpenSaveDialog2.linux" + Chr$(34) + " "+parameters$
    $End If

    f& = FreeFile
    Open TempDirFile$ For Input As #f&
    Line Input #f&, Filename$
    Close #f&

    ZZ = MessageBox("Chosen path+filename\n" + Filename$, "Info", MsgBox_OkOnly)

End Sub


'$INCLUDE:'InForm\InForm.ui'
